require "defines"
require "harvester"

currentVersion = "0.0.6"

migrations = {
	["unversioned"] = function()
		for _, harv in pairs(glob.harvesters) do
			-- Fix movement.
			if harv.filled then
				if harv.targetRefinery and harv.targetRefinery.valid then
					harv.onArrivalCallback = function(self) self.state = States.DroppingOre end
				else
					harv.onArrivalCallback = function(self) self.state = States.FindingRefinery end
				end
			elseif harv.refueling then
				if harv.targetRefinery and harv.targetRefinery.valid then
					harv.onArrivalCallback = function(self) self.state = States.ApproachedForRefuel end
				else
					harv.onArrivalCallback = function(self) self.state = States.FindingRefuelRefinery end
				end
			else
				harv.onArrivalCallback = function(self) self.state = States.FindingOre end
			end
			
		
			-- Stop animations.
			harv.animationState.currentAnimation = Animations.Rotating
			harv.animationState.animationState = AnimationStates.Rotating
			if harv.state == States.Animating then
				if harv.filled then
					harv.State = States.DroppingOre
				else
					harv.state = States.FindingOre
				end
			end
		end
	end,
	["0.0.3"] = function()
		migrations["unversioned"]()
	end,
	["0.0.4"] = function()
		migrations["unversioned"]()
	end,
}